<template>
  <button
    v-bind="$attrs"
    :disabled="disabled"
    :class="{
      'Button--iconLeft': iconLeft,
      'Button--labelled': !!label,
    }"
    :title="title || label"
    class="Button"
  >
    <slot>
      <span v-if="label" class="Button__Label">{{ label }}</span>
      <Icon v-if="icon" :icon="icon" class="Button__Icon" />
    </slot>
  </button>
</template>

<script lang="ts">
import { defineComponent } from 'vue'
import Icon from '@/components/Icon.vue'

export default defineComponent({
  components: { Icon },
  props: {
    label: String,
    title: String,
    icon: String,
    iconLeft: Boolean,
    disabled: {
      type: Boolean,
      default: false,
    },
  },
})
</script>

<style lang="scss" scoped>
@use '../style/variables' as v;

.Button {
  display: inline-flex;
  align-items: center;
  justify-content: space-between;
  padding: v.$spacing/2;
  border-width: 1px;
  border-style: solid;
  border-radius: v.$borderRadius;
  background-color: var(--button-background-color);
  background-position: center;
  color: var(--button-text-color);
  cursor: pointer;
  transition: background 200ms;

  :nth-child(2) {
    margin-left: 16px;
  }

  &__Label {
    order: 2;
    height: 1em;
    line-height: 1em;
  }

  &--labelled {
    padding-right: v.$spacing;
    padding-left: v.$spacing;
  }

  &__Icon {
    order: 3;
  }

  &--iconLeft {
    .Button__Icon {
      order: 1;
    }

    :nth-child(2) {
      margin-right: 16px;
      margin-left: 0;
    }
  }

  &:disabled {
    opacity: 50%;
    cursor: not-allowed;
  }

  &--outlined:not(:hover),
  &--outlined:disabled:hover,
  &:not(&--outlined):not(:disabled):hover {
    border-color: var(--button-background-color);
    background-color: transparent;
    color: var(--button-background-color);
  }

  &--noBorder {
    border-width: 0;
  }
}
</style>
